## seqan 1.4.1+dfsg

=== CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /CMakeLists.txt
#
# Main CMakeLists.txt file.
# ===========================================================================

project (seqan)

# ===========================================================================
# We require CMake 2.8.2.  Since it is available in the currently stable
# Debian, it should be available everywhere else, too.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)

# ===========================================================================
# Iff the file INST or SUA exists in the source root
# turn on SeqAn instrumentation for experimental data collection.
# ===========================================================================

if (EXISTS ${CMAKE_SOURCE_DIR}/INST OR EXISTS ${CMAKE_SOURCE_DIR}/SUA OR EXISTS ${CMAKE_SOURCE_DIR}/../SUA)
  set (SEQAN_INSTRUMENTATION YES)
else (EXISTS ${CMAKE_SOURCE_DIR}/INST OR EXISTS ${CMAKE_SOURCE_DIR}/SUA OR EXISTS ${CMAKE_SOURCE_DIR}/../SUA)
  set (SEQAN_INSTRUMENTATION NO)
endif (EXISTS ${CMAKE_SOURCE_DIR}/INST OR EXISTS ${CMAKE_SOURCE_DIR}/SUA OR EXISTS ${CMAKE_SOURCE_DIR}/../SUA)


# ===========================================================================
# Warn People About the Perils Of In-Source Builds
# ===========================================================================

if (EXISTS "$CMAKE_BINARY_DIR/CMakeLists.txt")
  if (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
    set (IN_SOURCE_BUILD YES)
  else (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
    message ("CAUTION: In-source builds are not allowed by default!")
    message ("")
    message ("(If you want to use Eclipse and have read the 'Getting Started,")
    message ("with Eclipse Tutorial' then see the instructions below.)")
    message ("")
    message ("Instead of doing in source builds, go to into the directory build")
    message ("and call CMake from there.")
    message ("We recommend you to create an additional directory level, this")
    message ("allows you to have multiple build configurations (e.g. Debug,")
    message ("Release) or project types.")
    message ("")
    message ("  cd build")
    message ("  mkdir Debug")
    message ("  cd Debug")
    message ("  cmake ../.. -DCMAKE_BUILD_TYPE=Debug")
    message ("")
    message ("NOTE: CMake has created some files in this directory that you have")
    message ("to remove before executing the above commands.")
    message ("")
    message ("  [Linux, Mac Os X]  rm -rf CMakeCache.txt CMakeFiles")
    message ("  [Windows]          del CMakeCache.txt ; rmdir /S CMakeFiles")
    message ("")
    message ("If you want to use Eclipse then you might want to have in-source")
    message ("builds because of limitations of Eclipse CDT4.  In this case")
    message ("Create a file in this directory called I_WANT_IN_SOURCE_BUILDS:")
    message ("")
    message ("  [Linux, Mac Os X]  touch I_WANT_IN_SOURCE_BUILDS")
    message ("  [Windows]          type nul >> I_WANT_IN_SOURCE_BUILDS")
    message ("")
    message (FATAL_ERROR "Please follow the instructions above.")
  endif (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
endif (EXISTS "$CMAKE_BINARY_DIR/CMakeLists.txt")

# ===========================================================================
# Setup Variables
# ===========================================================================

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING
         "Choose the type of build, options are: Debug Release RelWithDebInfo ..."
         FORCE)
endif (NOT CMAKE_BUILD_TYPE)

# Clear CTD executable list, will be set on reconfiguration.
set (SEQAN_CTD_EXECUTABLES CACHE INTERNAL "Global list of executables for workflow integration.")

# ===========================================================================
# Setup Modules and Find Packages.
# ===========================================================================

# Note that the find modules in util/make take precedence
# over the built-in ones from CMake.  This is used in
# FindBZip2, for example which we slightly modify.
set (CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}/util/cmake/FindTBB
    ${CMAKE_CURRENT_SOURCE_DIR}/util/cmake
    ${CMAKE_MODULE_PATH})

#message (STATUS "CMAKE_MODULE_PATH is ${CMAKE_MODULE_PATH}")

# ===========================================================================
# Add contrib to CMAKE_FIND_ROOT_PATH.
# ===========================================================================

include (SeqAnContribs)

# ===========================================================================
# Build Mode Branches
# ===========================================================================

message (STATUS "Initializing SeqAn Build System...")

set (SEQAN_USE_SEQAN_BUILD_SYSTEM TRUE CACHE INTERNAL "Use SeqAn build system." FORCE)

#set (SEQAN_PREFIX_SHARE .)
include (SeqAnBuildSystem)
set (SEQAN_ROOT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE INTERNAL "Root source directory." FORCE)
seqan_build_system_init ()

# ===========================================================================
# Include Subdirectories
# ===========================================================================

message (STATUS "Configuring core")
add_subdirectory (core)
message (STATUS "Configuring extras")
add_subdirectory (extras)
message (STATUS "Configuring docs")
add_subdirectory (docs)
message (STATUS "Configuring sandbox")
add_subdirectory (sandbox)

# ===========================================================================
# Include CPack
# ===========================================================================

include (package)

# ===========================================================================
# Check Optional Libraries, Print Usage
# ===========================================================================

#include (FeatureSummary)

# ===========================================================================
# Setup Common Tool Description for Generic Workflow Nodes
# ===========================================================================

include (SeqAnCtdSetup)

# ===========================================================================
# Legacy Build System Warning
# ===========================================================================

seqan_legacy_warning ()

=== docs/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /docs/CMakeLists.txt
#
# CMakeLists.txt file for docs.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (seqan_docs)

# Skip building docs if building app.
if (NOT ("${SEQAN_BUILD_SYSTEM}" STREQUAL "SEQAN_RELEASE") AND
    NOT ("${SEQAN_BUILD_SYSTEM}" STREQUAL "SEQAN_RELEASE_LIBRARY") AND
    NOT ("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP"))
    return ()
endif ()

find_package (PythonInterp)

set (SEQAN_DOCS_PATH "${CMAKE_SOURCE_DIR}/docs")

add_custom_target (docs
    WORKING_DIRECTORY ${SEQAN_DOCS_PATH}
    COMMAND ${PYTHON_EXECUTABLE} ${SEQAN_DOCS_PATH}/main.py ${CMAKE_SOURCE_DIR}/core/include ${CMAKE_SOURCE_DIR}/extras/include -d ${SEQAN_DOCS_PATH}/concepts -I ${CMAKE_SOURCE_DIR}/core -I ${CMAKE_SOURCE_DIR}/extras -d ${SEQAN_DOCS_PATH}/pages -o ${CMAKE_BINARY_DIR}/docs/html)

# You have to run "make docs" before calling make install.  We cannot
# add dependencies to the install target at the moment.  Also see:
# http://public.kitware.com/Bug/view.php?id=8438

install (DIRECTORY ${CMAKE_BINARY_DIR}/docs/html
        DESTINATION share/doc/seqan)

=== sandbox/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /sandbox/CMakeLists.txt
#
# CMakeLists.txt file for the sandbox folder.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (seqan_sandbox)

# Add all subdirectories with a CMakeLists.txt in them.

file (GLOB ENTRIES
      RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
      ${CMAKE_CURRENT_SOURCE_DIR}/[!.]*)
foreach (ENTRY ${ENTRIES})
  if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${ENTRY})
    if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${ENTRY}/CMakeLists.txt)
      add_subdirectory (${ENTRY})
    endif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${ENTRY}/CMakeLists.txt)
  endif (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${ENTRY})
endforeach (ENTRY ${ENTRIES})

=== core/apps/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /core/apps/CMakeLists.txt
#
# CMakeLists.txt file for the core apps.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (seqan_core_apps)
message (STATUS "Configuring core/apps")

# Register all apps in core.  The apps will be built in SEQAN_RELEASE mode or
# the apps called ${app} in APP:${app} mode.
seqan_register_apps ()

=== extras/demos/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /core/extras/CMakeLists.txt
#
# CMakeLists.txt file for the extras demos.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (seqan_extras_demos)
message (STATUS "Configuring extras/demos")

# Recursively register all demos in core and prefix their target/binary names
# with "demo_".  The demos will be built in DEVELOP mode, copied in
# SEQAN_RELEASE mode and left alone otherwise.
seqan_register_demos (demo_)

=== extras/tests/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /extras/tests/CMakeLists.txt
#
# CMakeLists.txt file for core tests.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (seqan_extras_tests)
message (STATUS "Configuring extras/tests")

# Setup flags and register all subdirectories.
seqan_register_tests ()

=== misc/makefile_project/Makefile ===
default: all

all: debug release

debug:
	$(MAKE) -C debug

release:
	$(MAKE) -C release

clean:
	$(MAKE) -C debug clean
	$(MAKE) -C release clean

.PHONY: default all debug release clean

=== misc/swig/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (SwigBinding)
#################################################################################
## get svn version
#################################################################################

find_package (Subversion)
if (Subversion_FOUND)
  Subversion_WC_INFO(${CMAKE_CURRENT_SOURCE_DIR} ER)
  set (SUBVERSION_REVISION ${ER_WC_REVISION})
endif (Subversion_FOUND)


#################################################################################
## Set Path Variables
#################################################################################
SET (SEQAN_LIBRARY_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../projects/library")

if (NOT SEQAN_LIBRARY)
  get_filename_component (SEQAN_LIBRARY_ABS ../../projects/library ABSOLUTE)
  set (SEQAN_LIBRARY ${SEQAN_LIBRARY_ABS} CACHE PATH
       "Path to SeqAn's parent folder (contains apps,demos,seqan)")
endif (NOT SEQAN_LIBRARY)


set (SEQAN_TARGET "Seqan")
################################################################################
# Define SeqAn Library Related Variables
#
# We define some variables that contain the base path of the library,
# a list of all headers in SeqAn, the modules and generated forwards.
################################################################################
get_filename_component (SEQAN_BASE_ABS ${SEQAN_LIBRARY}/seqan ABSOLUTE)

# A sorted list of all SeqAn headers goes into SEQAN_HEADERS.  We
# exclude the generated headers.
file (GLOB SEQAN_HEADERS_TMP ${SEQAN_BASE_ABS}/[A-z]*/[A-z]*.h)
file (GLOB SEQAN_SUPER_HEADERS ${SEQAN_BASE_ABS}/[A-z]*.h)
foreach (HEADER ${SEQAN_HEADERS_TMP})
  if (NOT ${HEADER} MATCHES ".*generated.*")
    list (APPEND SEQAN_HEADERS ${HEADER})
  endif (NOT ${HEADER} MATCHES ".*generated.*")
endforeach (HEADER ${SEQAN_HEADERS})
list (SORT SEQAN_HEADERS)

# A sorted list of all SeqAn modules goes into SEQAN_MODULES.
file (GLOB SEQAN_BASE_CONTENTS
      RELATIVE ${SEQAN_BASE_ABS}
      ${SEQAN_BASE_ABS}/[A-z]*)
foreach (ENTRY ${SEQAN_BASE_CONTENTS})
  if (IS_DIRECTORY ${SEQAN_BASE_ABS}/${ENTRY})
    list (APPEND SEQAN_MODULES ${ENTRY})
  endif (IS_DIRECTORY ${SEQAN_BASE_ABS}/${ENTRY})
endforeach (ENTRY ${SEQAN_BASE_CONTENTS})
list (SORT SEQAN_MODULES)
list (REMOVE_DUPLICATES SEQAN_MODULES)
set (SEQAN_TARGET "SeqAn")
################################################################################
# CMake Bug Workarounds
################################################################################

# For Non-GUI generators there is a bug in cmake: The SOURCE command in
# add_custom_target is not recognized there
set (NONGUI_GENERATORS "Unix Makefiles" "MinGW Makefiles")
list (FIND NONGUI_GENERATORS ${CMAKE_GENERATOR} FOUND)
if (FOUND EQUAL -1)
  set (SEQAN_GUI_SOURCES SOURCES ${SEQAN_HEADERS} ${SEQAN_SUPER_HEADERS})
endif (FOUND EQUAL -1)

################################################################################
# Forwards Generation For g++ Version >= 4.0
################################################################################
if (CMAKE_COMPILER_IS_GNUCXX)
  # Build a list of generated forwards headers.  Goes into SEQAN_FORWARDS.
  foreach (MODULE ${SEQAN_MODULES})
    list (APPEND SEQAN_FORWARDS
          ${SEQAN_BASE_ABS}/${MODULE}/${MODULE}_generated_forwards.h)
  endforeach (MODULE ${SEQAN_MODULES})

  # Now tell CMake that the forward headers can be generated with
  # build_forwards.py
  add_custom_command (
    OUTPUT ${SEQAN_FORWARDS}
    COMMAND ${PYTHON_EXECUTABLE} ${SEQAN_LIBRARY}/../../misc/build_forwards.py
            ${SEQAN_BASE_ABS} all
    DEPENDS ${SEQAN_HEADERS})
endif (CMAKE_COMPILER_IS_GNUCXX)

################################################################################
# SeqAn Pseudo Target
#
# We create a target ${SEQAN_TARGET} that contains all SeqAn headers,
# sources and the generated forwards.
################################################################################

# Note that SEQAN_FORWARDS is not defined when not compiling with g++
# which implies no forwards generation for non-g++ compilers.
add_custom_target (${SEQAN_TARGET} ALL
  DEPENDS ${SEQAN_HEADERS}
          ${SEQAN_FORWARDS}
          ${SEQAN_GUI_SOURCES}
)
################################################################################
# SWIG Build
#
# This is an example how to compile the interface swig file with cmake
# 
################################################################################

FIND_PACKAGE(SWIG REQUIRED)
INCLUDE(${SWIG_USE_FILE})
#find Python
FIND_PACKAGE(PythonLibs)

################################################################################
# Set Path Variables
################################################################################
INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
INCLUDE_DIRECTORIES(${SEQAN_LIBRARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

################################################################################
# Set SWIG Flags -> use "" for the default behaivour. This depends on the 
# target language 
################################################################################

SET(CMAKE_SWIG_FLAGS "")

SET_SOURCE_FILES_PROPERTIES(alignment.i PROPERTIES CPLUSPLUS ON)
SET_SOURCE_FILES_PROPERTIES(pattern_matching.i PROPERTIES CPLUSPLUS ON)
################################################################################
# indicate the files needed to be wrapped: target_name  target_language interface_file wrapper_file
################################################################################

SWIG_ADD_MODULE(alignment python alignment.i alignment.h)
SWIG_LINK_LIBRARIES(alignment ${PYTHON_LIBRARIES})
IF (WIN32)
  SET_TARGET_PROPERTIES ( _alignment PROPERTIES SUFFIX ".pyd")
ENDIF (WIN32)

INSTALL ( TARGETS _alignment LIBRARY DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/bin)

INSTALL ( FILES ${CMAKE_BINARY_DIR}/alignment.py DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/bin)

INSTALL(FILES example.py  DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/bin )

#SWIG_ADD_MODULE(pattern_matching python pattern_matching.i pattern_matching.h)
#SWIG_LINK_LIBRARIES(pattern_matching ${PYTHON_LIBRARIES})

#IF (WIN32)
##  SET_TARGET_PROPERTIES ( _pattern_matching PROPERTIES SUFFIX ".pyd")
#ENDIF (WIN32)

SET(CPACK_SET_DESTDIR "ON")
IF (WIN32)
    SET(CMAKE_INSTALL_PREFIX .)
ENDIF (WIN32)

SET(CPACK_GENERATOR "ZIP")
set (CPACK_PACKAGE_VERSION_PATCH "${SUBVERSION_REVISION}")
IF (WIN32)
    SET(CMAKE_INSTALL_PREFIX .)
    SET(CPACK_GENERATOR "ZIP")
ENDIF (WIN32)

include (InstallRequiredSystemLibraries)
INCLUDE (CPack) 
################################################################################
# to generate the package call  cpack -C CPackConfig.cmake 
################################################################################

=== core/apps/micro_razers/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /core/apps/micro_razers/CMakeLists.txt
#
# CMakeLists.txt file for MicroRazerS.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (core_apps_micro_razers)
message (STATUS "Configuring core/apps/micro_razers")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
set (SEQAN_FIND_DEPENDENCIES NONE)
find_package (SeqAn REQUIRED)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Update the list of file names below if you add source files to your application.
add_executable (micro_razers
               micro_razers.cpp
               outputFormat.h
               ../razers/paramChooser.h
               ../razers/param_tabs.h
               ../razers/param_tabs.cpp
               ../razers/param_tabs.inc)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (micro_razers ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (micro_razers)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install micro_razers in ${PREFIX}/bin directory
install (TARGETS micro_razers
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/micro_razers for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/genome.fa
               example/reads.fa
               example/reads.fa.result
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (micro_razers)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:micro_razers")
  set (CPACK_PACKAGE_NAME "micro_razers")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "MicroRazerS - Read Mapping With Controllable Sensitivity")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (micro_razers "MicroRazerS")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:micro_razers")

=== core/apps/pair_align/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /core/apps/pair_align/CMakeLists.txt
#
# CMakeLists.txt file for pair_align.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (core_apps_pair_align)
message (STATUS "Configuring core/apps/pair_align")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
set (SEQAN_FIND_DEPENDENCIES NONE)
find_package (SeqAn REQUIRED)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Update the list of file names below if you add source files to your application.
add_executable (pair_align pair_align.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (pair_align ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (pair_align)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install pair_align in ${PREFIX}/bin directory
install (TARGETS pair_align
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/pair_align for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (pair_align)

# ----------------------------------------------------------------------------
# Setup Command Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

#Include executable pair_align in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} pair_align CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:pair_align")
  set (CPACK_PACKAGE_NAME "pair_align")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "pair_align - Pairwise Sequence Alignment")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (pair_align "pair_align")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:pair_align")

=== core/apps/rabema/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /core/apps/rabema/CMakeLists.txt
#
# CMakeLists.txt file for Rabema.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (core_apps_rabema)
message (STATUS "Configuring core/apps/rabema")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
set (SEQAN_FIND_DEPENDENCIES ZLIB)
find_package (SeqAn REQUIRED)

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: RABEMA will not be built.")
  return ()
endif (NOT ZLIB_FOUND)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Preparation of SAM files, i.e. filling SEQ field of each record.
add_executable (rabema_prepare_sam prepare_sam.cpp sorting.h)
target_link_libraries (rabema_prepare_sam ${SEQAN_LIBRARIES})

# Building of GSI file from "perfect" SAM file and reference sequence.
add_executable (rabema_build_gold_standard
               rabema_build_gold_standard.cpp
               curve_smoothing.h
               find_hamming_simple_ext.h
               find_myers_ukkonen_ext.h
               find_myers_ukkonen_reads.h
               io_gsi.h
               rabema_stats.h
               ref_id_mapping.h
               sorting.h)
target_link_libraries (rabema_build_gold_standard ${SEQAN_LIBRARIES})

# Comparison of arbitrary read mapper SAM against GSI file.
add_executable (rabema_evaluate rabema_evaluate.cpp
               curve_smoothing.h
               find_hamming_simple_ext.h
               find_myers_ukkonen_ext.h
               find_myers_ukkonen_reads.h
               io_gsi.h
               rabema_stats.h
               ref_id_mapping.h
               sorting.h)
target_link_libraries (rabema_evaluate ${SEQAN_LIBRARIES})

# Small tool for helping in debugging.
add_executable (rabema_do_search do_search.cpp find_myers_ukkonen_ext.h)
target_link_libraries (rabema_do_search ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (rabema)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install rabema programs in ${PREFIX}/bin directory
install (TARGETS rabema_prepare_sam
                 rabema_build_gold_standard
                 rabema_evaluate
         DESTINATION bin)

# Install rabema in /bin directory
install (TARGETS rabema_prepare_sam rabema_build_gold_standard rabema_evaluate
        DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/pair_align for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (rabema)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} rabema_prepare_sam rabema_build_gold_standard rabema_evaluate CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:rabema")
    set (CPACK_PACKAGE_NAME "rabema")
    set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Rabema - Read Alignment Benchmark")
    set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
    set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

    seqan_configure_cpack_app (rabema "Rabema")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:rabema")

=== core/apps/razers/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /core/apps/razers/CMakeLists.txt
#
# CMakeLists.txt file for RazerS.
# ===========================================================================

cmake_minimum_required (VERSION 2.8.2)
project (core_apps_razers)
message (STATUS "Configuring core/apps/razers")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
set (SEQAN_FIND_DEPENDENCIES NONE)
find_package (SeqAn REQUIRED)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Update the list of file names below if you add source files to your application.
add_executable (razers razers.cpp
                      razers.h
                      param_tabs.h
                      param_tabs.cpp
                      param_tabs.inc
                      outputFormat.h
                      paramChooser.h
                      razers_matepairs.h
                      razers_spliced.h
                      readSimulator.h
                      param_tabs.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (razers ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (razers)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install razers in ${PREFIX}/bin directory
install (TARGETS razers
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/razers for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/genome.fa
               example/reads.fa
               example/reads2.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (razers)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} razers CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:razers")
  set (CPACK_PACKAGE_NAME "razers")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "RazerS - Read Mapping With Controllable Sensitivity")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (razers "RazerS")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:razers")

=== debian/changelog ===
seqan (1.4.1+dfsg-2) unstable; urgency=medium

  * Do proper manipulation of build options (thanks for the hint to
    Etienne Millon <me@emillon.org>)
    Closes: #759978, #752558

 -- Andreas Tille <tille@debian.org>  Mon, 01 Sep 2014 22:54:54 +0200

seqan (1.4.1+dfsg-1) unstable; urgency=medium

  * Fix FTBFS on many buildds due to RAM exhaustion (thanks to
    Dejan Latinovic <Dejan.Latinovic@imgtec.com> for the patch)
    Closes: #741288
  * debian/copyright (watch+rules): Remove compressed and unused
    JS files from upstream source

 -- Andreas Tille <tille@debian.org>  Thu, 31 Jul 2014 21:18:43 +0200

seqan (1.4.1-3) unstable; urgency=medium

  * debian/rules:
     - Run test suite only on powerfull architectures (amd64)
       at build time
  * deacticate test for apps splazers which fails since some point
    in time after uploading 1.4.1-2
    Closes: #733250

 -- Andreas Tille <tille@debian.org>  Tue, 28 Jan 2014 09:09:09 +0100

seqan (1.4.1-2) unstable; urgency=low

  * debian/seqan-apps.links: s/mason/seqan_mason
    Closes: #730751

 -- Andreas Tille <tille@debian.org>  Fri, 29 Nov 2013 11:39:01 +0100

seqan (1.4.1-1) unstable; urgency=low

  * New upstream version (patch became unneeded)
    Closes: #720995
  * debian/upstream:
     - Moved DOI+PMID to References
     - Added eprint
  * debian/reference: Deleted in favour of data in debian/upstream
  * debian/watch: adapted to changes at upstream
  * debian/orig-tar.sh: Removed because the removed file is not part
    of the source any more
  * debian/control:
     - debhelper 9
     - remove cdbs from / add python to Build-Depends
     - cme fix dpkg-control
     - canonical Vcs URLs
  * debian/copyright:
     - DEP5
     - Add Upstream-Contact according to latest discussion
     - Update Source to actual download tarball
  * debian/rules:
     - cdbs -> dh
     - Need to rename /usr/bin/join to /usr/bin/seqan-join to avoid
       name clash with coreutils
  * debian/generate_manpages: use help2man to autogenerate manpages
  * debian/README.Debian: Describe what apps go to /usr/bin and why
  * debian/seqan-apps.links: Update apps that should go to /usr/bin
    according to mail from upstream

 -- Andreas Tille <tille@debian.org>  Wed, 27 Nov 2013 10:26:17 +0100

=== debian/control ===
Source: seqan
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Soeren Sonnenburg <sonne@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               zlib1g-dev,
               libbam-dev,
               libboost-dev,
               dh-exec,
               help2man,
               python
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/seqan/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/seqan/trunk/
Homepage: http://www.seqan.de/

Package: seqan-apps
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: seqan-dev
Architecture: all
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files, documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Droping -fstack-protector flag helps **drastically** reducing memory consumption when building the package!!!!
# export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS | sed 's/-fstack-protector *//')  ## this simply tiggers #759978
export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector
# alternatively: export DEB_CXXFLAGS_STRIP='-fstack-protector'

DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

DEB_BUILD_ARCH          ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
    export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS | sed 's/-O[1-9]//') -O0 -mxgot
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	cd obj-$(DEB_BUILD_GNU_TYPE); make docs

override_dh_install:
	dh_install
	# /usr/bin/join is part of coreutils package: Avoid name conflict by renaming it to seqan-join
	# This solution is withdrawn in favour of just providing a set of binaries according to upstream
	# in /usr/bin (via symlink) while others go to /usr/lib/seqan/bin (see README.Debian)
	# mv $(CURDIR)/debian/seqan-apps/usr/bin/join $(CURDIR)/debian/seqan-apps/usr/bin/seqan-join
	#
	# Formerly binaries were installed into usr/lib/seqan/bin/
	# and only some of them were made available in /usr/bin via dh_link
	# Since there is no obvious reason for this neither is there any
	# documentation that explains the motivation this is commented here.
	#for APP in `find $(CURDIR)/obj*/apps -mindepth 1 -maxdepth 1 -executable -type f` ; do \
	#  cp -a $$APP $(CURDIR)/debian/seqan-apps/usr/lib/seqan/bin/ ; done
	# ------------------------------------------------------------------
	# Formerly readmes were named README.app.  It seems more consistent
	# to keep upstream documentation layout which in addition contains
	# some example files.  So the old code is commented here.
	#for APP in `find apps -name README` ; do \
	#  app=`echo $$APP | sed 's?.*apps/\(.\+\)/README?\1?'` ; \
	#  echo $$app ; \
	#  cp -a $$APP $(CURDIR)/debian/seqan-apps/usr/share/doc/seqan-apps/README.$$app ; \
	#done
	# ------------------------------------------------------------------
	# Delete additional LICENSE files
	find $(CURDIR)/debian/seqan-apps -type f -name LICENSE -delete
	if [ -d $(CURDIR)/debian/seqan-dev ] ; then \
	    find $(CURDIR)/debian/seqan-dev  -type f -name LICENSE -delete ; \
	    # Delete *.pyc files that somehow end up in seqan-dev documentation \
	    find $(CURDIR)/debian/seqan-dev -type f -name "*.pyc" -delete ; \
	fi

override_dh_auto_clean:
	dh_auto_clean
	find . -type f -name "*.pyc" -delete
	if [ -d orig ] ; then \
	  for header in `find orig -name "*generated_forwards.h"` ; do \
	    mv $${header} `echo $$header | sed 's?orig/??'` ; \
	  done ; \
	fi
	rm -rf orig

override_dh_link:
	dh_link
	# we generate only those manpages where binaries are linked to /usr/bin
        # since dh_link is executed after dh_installmanpages this is done here
	$(CURDIR)/debian/generate_manpages

override_dh_auto_test:
# Run test suite only on powerfull architectures (amd64) at build time
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64))
	dh_auto_test
else
	echo "Do not run test suite when building on architecture $(DEB_HOST_ARCH)"
endif

get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
version=3
opts="uversionmangle=s/$/+dfsg/" \
  http://packages.seqan.de/ .*/seqan-src-([.\d]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
